#include <sstream>
#include "ezwin.h"
using namespace std ;

// This must be imported.
extern void (*fTab[])(void) ;

const int Size = 10 ;

SimpleWindow *pW;

void TurnOn(int z)
{
	float cellX = pW->GetWidth()/Size ;
	float cellY = pW->GetHeight()/Size ;
	int i = z%Size ;
	int j = (z/Size)%Size ;
	ostringstream winName ;
	if (z < Size*Size) {
		winName << z ;
		Position Pul(i*cellX, j*cellY);
		Position Plr((i+1)*cellX, (j+1)*cellY);
		pW->RenderRectangle(Pul, Plr, Red) ;
		pW->RenderText(Pul, Plr, winName.str(), Black, Red) ;
	}
}

Position home(0.0f, 0.0f) ;

void PlotPoints(void (*f) (void))
{
	float cellX = pW->GetWidth()/Size ;
	float cellY = pW->GetHeight()/Size ;
	int i, j, z ;
	for (z=0; z<100; ++z) {
		i = z%Size ;
		j = (z/Size)%Size ;
		ostringstream winName ;
		winName << z ;
		Position Pul(i*cellX, j*cellY);
		Position Plr((i+1)*cellX, (j+1)*cellY);
		pW->RenderText(Pul, Plr, winName.str(), Black, White) ;
	}
	f() ;
}

int funcIndex = 0 ;

int refreshPlot()
{
	PlotPoints(fTab[funcIndex]) ;
	return 0 ;
}

int nextPlot(const Position &Ignored)
{
	pW->Close() ;
	delete pW ;
	if (fTab[++funcIndex] == NULL)
		funcIndex = 0 ;
	ostringstream winName ;
	winName << "Func " << funcIndex ;
	pW = new SimpleWindow(winName.str(), 18.0f, 18.0f, home) ;
	pW->Open() ;
	pW->SetMouseClickCallback(nextPlot) ;
	pW->SetRefreshCallback(refreshPlot) ;
	PlotPoints(fTab[funcIndex]) ;
	return 0 ;
}

int ApiMain() 
{
	pW = new SimpleWindow("Func 0", 18.0f, 18.0f, home) ;
	pW->Open() ;
	pW->SetMouseClickCallback(nextPlot) ;
	pW->SetRefreshCallback(refreshPlot) ;
	PlotPoints(fTab[0]) ;
	return 0 ;
}

int ApiEnd()
{
	pW->Close() ;
	return 0 ;
}
